diff --git a/src/backend/utils/activity/pgstat_database.c b/src/backend/utils/activity/pgstat_database.c
index 7149f22..7c260a4 100644
--- a/src/backend/utils/activity/pgstat_database.c
+++ b/src/backend/utils/activity/pgstat_database.c
@@ -363,6 +363,7 @@ pgstat_database_flush_cb(PgStat_EntryRef *entry_ref, bool nowait)
 {
 	PgStatShared_Database *sharedent;
 	PgStat_StatDBEntry *pendingent;
+	TimestampTz ts = GetCurrentTimestamp();
 
 	pendingent = (PgStat_StatDBEntry *) entry_ref->pending;
 	sharedent = (PgStatShared_Database *) entry_ref->shared_stats;
@@ -370,6 +371,9 @@ pgstat_database_flush_cb(PgStat_EntryRef *entry_ref, bool nowait)
 	if (!pgstat_lock_entry(entry_ref, nowait))
 		return false;
 
+	if ((sharedent)->stats.stat_reset_timestamp == 0)
+		(sharedent)->stats.stat_reset_timestamp = ts;
+
 #define PGSTAT_ACCUM_DBCOUNT(item)		\
 	(sharedent)->stats.item += (pendingent)->item
 
